class Decoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  blank_id : int
  context_size : int
  vocab_size : int
  embedding : __torch__.torch.nn.modules.sparse.Embedding
  conv : __torch__.torch.nn.modules.conv.Conv1d
  def forward(self: __torch__.decoder.Decoder,
    y: Tensor,
    need_pad: bool=True) -> Tensor:
    _0 = __torch__.torch.jit._trace.is_tracing
    _1 = __torch__.icefall.utils.is_jit_tracing
    need_pad0 = unchecked_cast(bool, need_pad)
    y0 = torch.to(y, 4)
    if _0():
      embedding = self.embedding
      embedding_out = (embedding).forward(y0, )
    else:
      embedding0 = self.embedding
      _2 = (embedding0).forward(torch.clamp(y0, 0), )
      _3 = torch.unsqueeze(torch.ge(y0, 0), -1)
      embedding_out = torch.mul(_2, _3)
    context_size = self.context_size
    if torch.gt(context_size, 1):
      embedding_out1 = torch.permute(embedding_out, [0, 2, 1])
      if need_pad0:
        context_size0 = self.context_size
        _4 = [torch.sub(context_size0, 1), 0]
        embedding_out2 = torch.pad(embedding_out1, _4)
      else:
        if torch.__not__(_1()):
          _5 = torch.size(embedding_out1, -1)
          context_size1 = self.context_size
          if torch.eq(_5, context_size1):
            pass
          else:
            ops.prim.RaiseException("AssertionError: ")
        else:
          pass
        embedding_out2 = embedding_out1
      conv = self.conv
      embedding_out3 = (conv).forward(embedding_out2, )
      embedding_out4 = torch.permute(embedding_out3, [0, 2, 1])
      embedding_out0 = embedding_out4
    else:
      embedding_out0 = embedding_out
    embedding_out5 = __torch__.torch.nn.functional.relu(embedding_out0, False, )
    return embedding_out5
